{Originally written by Soft Machine}
{Ported to 8bpp by TCA of NewOrder}

program CaveManDemo;
uses newfrontier,objgfx8,keys;
const pl:array[0..15,1..3] of byte=((0,0,0),(20,20,20),(40,40,40),
                                    (56,32,16),(63,46,38),(46,7,28),
                                    (16,16,48),(18,20,50),(20,24,52),
                                    (22,28,54),(24,32,56),(26,36,58),
                                    (28,40,60),(30,44,62),(32,48,63),
                                    (63,63,63));

type TCaveMan=object(Tgfx8)
       Screen:TScreen8;
       BlitTable:array[0..20] of longint;
       Blits:word;
       CaveDude:word;
       CaveDudeTable:array[0..23] of longint;
       constructor init;
       procedure run;
       destructor done; virtual;
     end;

Constructor TCaveMan.Init;
var i:word;
    result:longint;
    f:file;
begin
 inherited init;

 if not getmem(170,230) then
  begin
   writeln('Error allocating double buffer');
   halt
  end;

 assign(f,'softlogo.blt');
 reset(f,1);
 getmem32(Blits,filesize(f));
 if Blits=0 then
  begin
   writeln('Error allocating logo image buffer');
   halt
  end;
 blockread32(f,ptr48(Blits,0),filesize(f),result);
 close(f);

 assign(f,'cavedude.blt');
 reset(f,1);
 getmem32(CaveDude,filesize(f));
 if CaveDude=0 then
  begin
   writeln('Error allocating caveman image buffer');
   halt
  end;
 blockread32(f,ptr48(CaveDude,0),filesize(f),result);
 close(f);

 assign(f,'blttable.idx');
 reset(f,1);
 blockread(f,BlitTable,sizeof(BlitTable));
 close(f);

 assign(f,'cdtable.idx');
 reset(f,1);
 blockread(f,CaveDudeTable,sizeof(CaveDudeTable));
 close(f);

 Screen.init;

 with screen do
  begin
   if Screen.IsVesaInstalled<>VESA_Ok then
    begin
     writeln('VESA not found');
     halt
    end;
   if not Screen.SetMode(_640x480x8bpp) then
    begin
     writeln('640x480x8bpp is not available');
     halt
    end;
   for i:=0 to 15 do
    SetRGBpalette(i,pl[i][1],pl[i][2],pl[i][3]);
   clear(6);
   for i:=0 to 7 do
    begin
     rectangle(399-i,199-i,570+i,430+i,14-i);
     rectangle(69-i,49-i,170+i,150+i,14-i);
     rectangle(69-i,199-i,170+i,300+i,14-i);
     rectangle(69-i,349-i,170+i,450+i,14-i);
    end;
 end; {with}

end;

procedure TCaveMan.Run;
var i,j,k,l,z,x:integer;
    Finished:boolean;
    count,retraceCount:byte;
    bgcolour:byte;
    Flipit:boolean;
begin
 for j:=0 to 63 do
  begin
   for i:=0 to 15 do
    screen.SetRgbPalette(i,pl[i,1]*j div 63,pl[i,2]*j div 63,pl[i,3]*j div 63);
    screen.waitForretrace;
  end;
 SetKbdInterrupt;
 RetraceCount:=1;
 bgcolour:=15;
 i:=0;
 j:=1;
 k:=11;
 l:=1;
 z:=0;
 x:=1;
 Finished:=FALSE;
 repeat
  bar(0,0,99,99,0);
  putblit(0,0,ptr48(Blits,BlitTable[i]));
  screen.copybuf(70,50,self,0,0,99,99);
  bar(0,0,99,99,0);
  putblit(0,0,ptr48(Blits,BlitTable[k]));
  screen.copybuf(70,200,self,0,0,99,99);
  bar(0,0,99,99,0);
  putblit(0,0,ptr48(Blits,BlitTable[i]));
  screen.rectangle(70+z*2,350+z*2,169-z*2,449-z*2,0);
  screen.rectangle(71+z*2,351+z*2,168-z*2,448-z*2,0);
  screen.scalebuf(72+z*2,352+z*2,167-z*2,447-z*2,self,0,0,99,99);

  clear(bgcolour);
  putblit(0,0,ptr48(CaveDude,CaveDudeTable[z]));
  screen.CopyBuf(400,200,self,0,0,169,229);
  inc(i,j);
  if i in [0,20] then j:=-j;
  inc(k,l);
  if k in [0,20] then l:=-l;
  inc(z,x);
  if z in [0,23] then x:=-x;
  if keypressed then
   case upcase(readkey) of
    #27,'Q':Finished:=TRUE;
    ' ':if BgColour=15 then BgColour:=0 else inc(BgColour);
    '-':if RetraceCount<3 then inc(RetraceCount);
    '+':if RetraceCount>0 then Dec(RetraceCount);
   end;
  for count:=1 to RetraceCount do
   screen.waitforretrace;
 until Finished or (KeyHit[1]);
 RestoreKbdInterrupt;
end;

Destructor TCaveMan.Done;
begin
 inherited done;
 freemem32(Blits);
 freemem32(CaveDude);
 Screen.Done;
end;

var CaveMan:^TCaveMan;

begin
 new(CaveMan,init);
 CaveMan^.Run;
 dispose(CaveMan,done)
end.